{

open Util
open Dparser

(* Note added due to LGPL terms.

This file was edited by Valerio Bigiani, AKA The Bigg, starting from
6 November 2005. All changes for this file are listed in
diffs/src.dlexer.mll.diff file, as the output of a diff -p -E -b command.

It was originally taken from Westley Weimer's WeiDU 185. *)

(*
** Keyword hashtable
*)

let string_of lb = (Lexing.lexeme lb)

let lexicon = Hashtbl.create 211
let _ = List.iter 
    (fun (key, token) -> Hashtbl.add lexicon key token)
    [ 
      ("LOOKUP_IDS_SYMBOL_OF_INT", SET_IDS_SYMBOL_OF_INT) ;
	    ("ADD_MAP_NOTE", ADD_MAP_NOTE);
	    ("ACTION_BASH_FOR", ACTION_BASH_FOR) ;
	    ("ACTION_FOR_EACH", ACTION_FOR_EACH) ;
      ("ACTION_IF", ACTION_IF) ;
      ("ACTION_READLN", ACTION_READLN);
      ("ADD_CRE_ITEM", ADD_CRE_ITEM) ;
      ("ADD_GAME_NPC", PATCH_GAM) ;
      ("ADD_KIT", ADD_KIT) ;
      ("ADD_KNOWN_SPELL", ADD_KNOWN_SPELL) ;
      ("ADD_MUSIC", ADD_MUSIC) ;
      ("ADD_PROJECTILE", ADD_PROJECTILE) ;
      ("ADD_STATE_TRIGGER", ADD_STATE_TRIGGER) ;
      ("ADD_STORE_ITEM", ADD_STORE_ITEM);
      ("ADD_TRANS_ACTION", ADD_TRANS_ACTION) ;
      ("ADD_TRANS_TRIGGER", ADD_TRANS_TRIGGER) ;
      ("AFTER", AFTER) ;
      ("ALLOW_MISSING", ALLOW_MISSING) ;
      ("ALWAYS", ALWAYS) ;
      ("APPEND", APPEND);
      ("APPENDI", APPENDI);
      ("APPEND_COL", APPEND_COL);
      ("APPEND_FILE", APPEND_FILE);
      ("APPEND_FILE_EVALUATE", APPEND_FILE_EVALUATE);
      ("APPEND_EARLY", APPEND_EARLY);
      ("APPEND_OUTER", APPEND_OUTER);
      ("APPLY_BCS_PATCH", APPLY_BCS_PATCH) ;
      ("APPLY_BCS_PATCH_OR_COPY", APPLY_BCS_PATCH_OR_COPY) ;
      ("ASK_EVERY_COMPONENT", ASK_EVERY_COMPONENT);
      ("AT_EXIT", AT_EXIT);
      ("AT_INTERACTIVE_EXIT", AT_INTERACTIVE_EXIT) ;
      ("AT_INTERACTIVE_NOW", AT_INTERACTIVE_NOW) ;
      ("AT_INTERACTIVE_UNINSTALL", AT_INTERACTIVE_UNINSTALL) ;
      ("AT_NOW", AT_NOW) ;
      ("AT_UNINSTALL", AT_UNINSTALL) ;
      ("AUTHOR", AUTHOR);
      ("AUTO_TRA", AUTO_TRA);
      ("A_B_P", APPLY_BCS_PATCH) ;
      ("A_S_T", ADD_STATE_TRIGGER) ;
      ("A_T_T", ADD_TRANS_TRIGGER) ;
      ("BACKUP", BACKUP) ;
      ("BEFORE", BEFORE) ;
      ("BEGIN", BEGIN) ;
      ("BRANCH", BRANCH) ;
      ("MAKE_BIFF", BIFF) ;
      ("BUT_ONLY_IF_IT_CHANGES", BUT_ONLY_IF_IT_CHANGES);
      ("BUT_ONLY", BUT_ONLY_IF_IT_CHANGES) ;
      ("CASE_INSENSITIVE", CASE_INSENSITIVE) ;
      ("CASE_SENSITIVE", CASE_SENSITIVE) ;
      ("CHAIN", CHAIN3);
      ("CHAIN2", CHAIN2);
      ("CHAIN3", CHAIN3);
      ("CLEAR_IDS_MAP", CLEAR_IDS_MAP) ;
      ("CLEAR_MEMORY", CLEAR_MEMORY);
      ("COMPILE", COMPILE);
      ("COMPILE_BAF_TO_BCS", COMPILE_BAF_TO_BCS);
      ("COMPILE_D_TO_DLG", COMPILE_D_TO_DLG);
      ("COPY", COPY);
      ("COPY_ALL_GAM_FILES", COPY_ALL_GAM_FILES);
      ("COPY_EXISTING", COPY_EXISTING);
      ("COPY_EXISTING_REGEXP", COPY_EXISTING_REGEXP);
      ("COPY_LARGE", COPY_LARGE);
      ("COPY_RANDOM", COPY_RANDOM);
      ("COPY_TRANS", COPY_TRANS);
      ("COUNT_2DA_ROWS", COUNT_2DA_ROWS) ;
      ("COUNT_REGEXP_INSTANCES", COUNT_REGEXP_INSTANCES) ;
      ("DECOMPILE_BCS_TO_BAF", DECOMPILE_BCS_TO_BAF);
      ("DECOMPILE_DLG_TO_D", DECOMPILE_DLG_TO_D);
      ("DEFINE_ACTION_MACRO", DEFINE_ACTION_MACRO) ;
      ("DEFINE_MACRO_ACTION", DEFINE_ACTION_MACRO) ;
      ("DEFINE_MACRO_PATCH", DEFINE_PATCH_MACRO) ;
      ("DEFINE_PATCH_MACRO", DEFINE_PATCH_MACRO) ;
      ("DELETE_BYTES", DELETE_BYTES);
      ("DEPRECATED", DEPRECATED);
      ("DESCRIBE_ITEM", DESCRIBE_ITEM) ;
      ("DESIGNATED", DESIGNATED);
      ("DO", DO) ;
      ("ELSE", ELSE) ;
      ("END", END) ;
      ("EQUIP", EQUIP);
      ("EVALUATE_REGEXP", EVALUATE_REGEXP);
      ("EXACT_MATCH", EXACT_MATCH);
      ("EXIT", EXIT) ;
      ("EXTEND",EXTEND_BOTTOM) ;
      ("EXTEND_BOTTOM", EXTEND_BOTTOM) ;
      ("EXTEND_BOTTOM_REGEXP", EXTEND_BOTTOM_REGEXP);
      ("EXTEND_TOP", EXTEND_TOP) ;
      ("EXTEND_TOP_REGEXP", EXTEND_TOP_REGEXP);
      ("EXTERN", EXTERN) ;
      ("EVALUATE_BUFFER", EVALUATE_BUFFER) ;
      ("FAIL", FAIL);
      ("FIRST", FIRST) ;
      ("FLAGS", FLAGS);
      ("FOR", FOR) ;
      ("FORBID_COMPONENT", FORBID_COMPONENT) ;
      ("FORBID_FILE", FORBID_FILE) ;
      ("FORCED_SUBCOMPONENT", FORCED_SUBCOMPONENT) ;
      ("FROM", FROM) ;
      ("GAME_IS", GAME_IS) ;
      ("GET_STRREF", GET_STRREF) ;
      ("GLOB", GLOB);
      ("GOTO", GOTO) ;
      ("GROUP", GROUP) ;
      ("IDS_OF_SYMBOL", IDS_OF_SYMBOL) ;
      ("IF", IF) ;
      ("IF_EVAL", IF_EVAL) ;
      ("IF_FILE_EXISTS", IF_FILE_EXISTS) ;
      ("IF_SIZE_IS", IF_SIZE_IS) ;
      ("IN", IN) ;
      ("INCLUDE", INCLUDE) ;
      ("INNER_ACTION", INNER_ACTION) ;
      ("INNER_PATCH", INNER_PATCH) ;
      ("INNER_PATCH_FILE", INNER_PATCH_FILE) ;
      ("INNER_PATCH_SAVE", INNER_PATCH_SAVE) ;
      ("INSERT_2DA_ROW", INSERT_2DA_ROW) ;
      ("INSERT_BYTES", INSERT_BYTES);
      ("INSERT_FILE", INSERT_FILE);
      ("INSTALL_BY_DEFAULT", INSTALL_BY_DEFAULT) ;
      ("INTERJECT", INTERJECT);
      ("INTERJECT_COPY_TRANS", INTERJECT_COPY_TRANS);
      ("INTERJECT_COPY_TRANS2", INTERJECT_COPY_TRANS2);
      ("INTERJECT_COPY_TRANS3", INTERJECT_COPY_TRANS3);
      ("INTERJECT_COPY_TRANS4", INTERJECT_COPY_TRANS4);
      ("IS_AN_INT", IS_AN_INT);
      ("I_C_T", INTERJECT_COPY_TRANS);
      ("I_C_T2", INTERJECT_COPY_TRANS2);
      ("I_C_T3", INTERJECT_COPY_TRANS3);
      ("I_C_T4", INTERJECT_COPY_TRANS4);
      ("I_S_I", IF_SIZE_IS) ;
      ("JOURNAL", JOURNAL) ;
      ("LANGUAGE", LANGUAGE) ;
      ("LAST", LAST) ;
      ("LAUNCH_ACTION_MACRO", LAUNCH_ACTION_MACRO) ;
      ("LAUNCH_PATCH_MACRO", LAUNCH_PATCH_MACRO) ;
      ("LAUNCH_MACRO_PATCH", LAUNCH_PATCH_MACRO) ;
      ("LAUNCH_MACRO_ACTION", LAUNCH_ACTION_MACRO) ;
      ("LOAD", LOAD) ;
      ("LOAD_TRA", LOAD_TRA) ;
      ("LOCAL_SET", LOCAL_SET) ;
      ("LOCAL_SPRINT", LOCAL_SPRINT) ;
      ("LOCAL_TEXT_SPRINT", LOCAL_TEXT_SPRINT) ;
      ("MENU_STYLE", MENU_STYLE) ;
      ("MKDIR", MKDIR) ;
      ("MOD_IS_INSTALLED", MOD_IS_INSTALLED) ;
      ("NO_IF_EVAL_BUG", NO_IF_EVAL_BUG);
      ("NO_LOG_RECORD", NO_LOG_RECORD) ;
      ("OUTER_FOR", OUTER_FOR) ;
      ("OUTER_INNER_PATCH", OUTER_PATCH) ;
      ("OUTER_INNER_PATCH_SAVE", OUTER_PATCH_SAVE) ;
      ("OUTER_PATCH", OUTER_PATCH) ;
      ("OUTER_PATCH_SAVE", OUTER_PATCH_SAVE) ;
      ("OUTER_SET", OUTER_SET) ;
      ("OUTER_SPRINT", OUTER_SPRINT) ;
      ("OUTER_TEXT_SPRINT", OUTER_TEXT_SPRINT) ;
      ("OUTER_WHILE", OUTER_WHILE);
	    ("PATCH_BASH_FOR", PATCH_BASH_FOR) ;
	    ("PATCH_FOR_EACH", PATCH_FOR_EACH) ;
      ("PATCH_GAM", PATCH_GAM) ;
      ("PATCH_IF", PATCH_IF) ;
      ("PATCH_SILENT", PATCH_SILENT) ;
      ("PATCH_PRINT", PATCH_PRINT);
      ("PATCH_VERBOSE", PATCH_VERBOSE);
      ("SPRINT", SPRINT);
      ("SNPRINT", SNPRINT);
      ("PRINT", PRINT);
      ("RANDOM", RANDOM);
      ("RANDOM_SEED", RANDOM_SEED);
      ("PATCH_RANDOM_SEED", PATCH_RANDOM_SEED);
      ("PATCH_READLN", PATCH_READLN);
      ("READ_2DA_ENTRIES_NOW", READ_2DA_ENTRIES_NOW) ;
      ("READ_2DA_ENTRY", READ_2DA_ENTRY) ;
      ("READ_2DA_ENTRY_FORMER", READ_2DA_ENTRY_FORMER) ;
      ("READ_ASCII", READ_ASCII);
      ("READ_STRREF", READ_STRREF);
      ("READ_BYTE", READ_BYTE) ;
      ("READ_SBYTE", READ_SBYTE) ;
      ("READ_SSHORT", READ_SSHORT) ;
      ("READ_LONG", READ_LONG) ;
      ("READ_SHORT", READ_SHORT) ;
      ("REINCLUDE", REINCLUDE) ;
      ("REMOVE_CRE_ITEM", REMOVE_CRE_ITEM) ;
      ("REMOVE_KNOWN_SPELL", REMOVE_KNOWN_SPELL) ;
      ("REMOVE_MEMORIZED_SPELL", REMOVE_MEMORIZED_SPELL) ;
      ("REMOVE_STORE_ITEM", REMOVE_STORE_ITEM) ;
      ("REPLACE", REPLACE) ;
      ("REPLACE_ACTION_TEXT", REPLACE_ACTION_TEXT) ;
      ("REPLACE_ACTION_TEXT_PROCESS", REPLACE_ACTION_TEXT_PROCESS) ;
      ("REPLACE_ACTION_TEXT_PROCESS_REGEXP", REPLACE_ACTION_TEXT_PROCESS_REGEXP) ;
      ("REPLACE_ACTION_TEXT_REGEXP", REPLACE_ACTION_TEXT_REGEXP) ;
      ("REPLACE_BCS_BLOCK", REPLACE_BCS_BLOCK) ;
      ("REPLACE_BCS_BLOCK_REGEXP", REPLACE_BCS_BLOCK_REGEXP) ;  
      ("REPLACE_CRE_ITEM", REPLACE_CRE_ITEM);
      ("REPLACE_EVALUATE", REPLACE_EVALUATE) ;
      ("REPLACE_SAY", REPLACE_SAY) ;
      ("REPLACE_STATE_TRIGGER", REPLACE_STATE_TRIGGER) ;
      ("REPLACE_TEXTUALLY", REPLACE_TEXTUALLY) ;
      ("REPLACE_TRIGGER_TEXT", REPLACE_TRIGGER_TEXT) ;
      ("REPLACE_TRIGGER_TEXT_REGEXP", REPLACE_TRIGGER_TEXT_REGEXP) ;
      ("REPLY", REPLY) ;
      ("REQUIRE_COMPONENT", REQUIRE_COMPONENT) ;
      ("REQUIRE_FILE", REQUIRE_FILE) ;
      ("REQUIRE_PREDICATE", REQUIRE_PREDICATE) ;
      ("R_A_T", REPLACE_ACTION_TEXT) ;
      ("R_A_T_P_R", REPLACE_ACTION_TEXT_PROCESS_REGEXP) ;
      ("R_B_B", REPLACE_BCS_BLOCK) ;
      ("R_B_B_RE", REPLACE_BCS_BLOCK_REGEXP) ;
      ("R_S_T", REPLACE_STATE_TRIGGER) ;
      ("R_T_T", REPLACE_TRIGGER_TEXT) ;
      ("SAY", SAY) ;
      ("SAY_EVALUATED", SAY_EVALUATED) ;
      ("SCRIPT_STYLE", SCRIPT_STYLE) ;
      ("SET", SET);
      ("SET_2DA_ENTRY", SET_2DA_ENTRY) ;
      ("SET_2DA_ENTRY_LATER", SET_2DA_ENTRY_LATER) ;
      ("SET_2DA_ENTRIES_NOW", SET_2DA_ENTRIES_NOW) ;
      ("SET_WEIGHT", SET_WEIGHT) ;
      ("SILENT", SILENT) ;
      ("SOLVED_JOURNAL", SOLVED_JOURNAL) ;
      ("STATE_WHICH_SAYS", STATE_WHICH_SAYS) ;
      ("STRING_COMPARE", STRING_COMPARE) ;
      ("STRING_COMPARE_CASE", STRING_COMPARE_CASE) ;
      ("STRING_EQUAL", STRING_EQUAL) ;
      ("STRING_EQUAL_CASE", STRING_EQUAL_CASE) ;
      ("STRING_COMPARE_REGEXP", STRING_MATCHES_REGEXP) ;
      ("STRING_MATCHES_REGEXP", STRING_MATCHES_REGEXP) ;
      ("STRING_CONTAINS_REGEXP", STRING_CONTAINS_REGEXP) ;
      ("STRING_SET", STRING_SET) ;
      ("STRING_SET_EVALUATE", STRING_SET_EVALUATE) ;
      ("STRING_SET_RANGE", STRING_SET_RANGE) ;
      ("STR_CMP", STRING_COMPARE) ;
      ("SUBCOMPONENT", SUBCOMPONENT) ;
      ("SUB_COMPONENT", SUBCOMPONENT) ;
      ("TEXT_SPRINT", TEXT_SPRINT) ;
      ("THEN", THEN) ;
      ("TO_LOWER", TO_LOWER) ;
      ("TO_UPPER", TO_UPPER) ;
      ("TWOHANDED", TWOHANDED);
      ("UNINSTALL", UNINSTALL) ;
      ("UNLESS", UNLESS) ;
      ("UNSOLVED_JOURNAL", UNSOLVED_JOURNAL) ;
      ("USING", USING) ;
      ("VARIABLE_IS_SET", VARIABLE_IS_SET) ;
      ("VERBOSE", VERBOSE) ;
      ("WEIGHT", WEIGHT) ;
      ("WHILE", WHILE) ;
      ("WRITE_ASCII", WRITE_ASCII) ;
      ("WRITE_BYTE", WRITE_BYTE) ;
      ("WRITE_EVALUATED_ASCII", WRITE_EVALUATED_ASCII) ;
      ("WRITE_FILE", WRITE_FILE) ;
      ("WRITE_LONG", WRITE_LONG) ;
      ("WRITE_SHORT", WRITE_SHORT) ;

      (* predicates *)
      ("FILE_EXISTS", FILE_EXISTS ) ;
      ("FILE_MD5", FILE_MD5 ) ;
      ("FILE_EXISTS_IN_GAME", FILE_EXISTS_IN_GAME ) ;
      ("FILE_SIZE", FILE_SIZE ) ;
      ("FILE_CONTAINS", FILE_CONTAINS ) ;
      ("FILE_CONTAINS_EVALUATED", FILE_CONTAINS_EVALUATED ) ;
      ("AND", AND) ;
      ("OR", OR) ;
      ("NOT", NOT) ;

      ("BAND", BAND) ;
      ("BOR", BOR) ;
      ("BNOT", BNOT) ;
      ("BXOR", BXOR) ;
      ("BLSL", BLSL) ;
      ("BLSR", BLSR) ;
      ("BASR", BASR) ;
    ] 

(*
** Buffer processor
*)
 



} 

let decdigit = ['0'-'9']
let octdigit = ['0'-'7']
let letter = ['a' - 'z' 'A'-'Z']

let blank = [' ' '\012' '\r']

rule initial = parse 	
  "/*"  { adj lexbuf ; let _ = comment lexbuf in initial lexbuf}
| "//"  { adj lexbuf ; endline lexbuf }
| blank	{ adj lexbuf ; initial lexbuf}
| '\t'  { tab (); initial lexbuf }
| '\n'  { newline (); initial lexbuf }
| '('   { adj lexbuf ; LPAREN } 
| ')'   { adj lexbuf ; RPAREN } 
| '?'   { adj lexbuf ; QUESTION } 
| ':'   { adj lexbuf ; COLON } 
| ';'   { adj lexbuf ; SEMICOLON }
| '+'   { adj lexbuf ; PLUS } 
| '-'   { adj lexbuf ; MINUS } 
| '*'   { adj lexbuf ; TIMES } 
| "**"   { adj lexbuf ; TIMESTIMES } 
| '/'   { adj lexbuf ; DIVIDE } 
| '='   { adj lexbuf ; EQUALS } 
| '>'   { adj lexbuf ; GT } 
| '<'   { adj lexbuf ; LT } 
| '+'   { adj lexbuf ; PLUS }
| '^'   { adj lexbuf ; STRING_CONCAT }

| "+="  { adj lexbuf ; PLUS_EQUALS }
| "-="  { adj lexbuf ; MINUS_EQUALS }
| "*="  { adj lexbuf ; TIMES_EQUALS }
| "/="  { adj lexbuf ; DIVIDE_EQUALS }
| "|="  { adj lexbuf ; OR_EQUALS }
| "&="  { adj lexbuf ; AND_EQUALS }
| "<<=" { adj lexbuf ; BLSL_EQUALS }
| ">>=" { adj lexbuf ; BLSR_EQUALS }
| "^^=" { adj lexbuf ; BXOR_EQUALS }

| "!"   { adj lexbuf ; NOT }
| "&"  { adj lexbuf ; BAND }
| "|"  { adj lexbuf ; BOR }
| "^^" { adj lexbuf ; BXOR }
| "&&"  { adj lexbuf ; AND }
| "||"  { adj lexbuf ; OR }
| "<<"  { adj lexbuf ; BLSL }
| ">>"  { adj lexbuf ; BLSR }
| "`"   { adj lexbuf ; BNOT }

| ">="   { adj lexbuf ; GTE }
| "<="   { adj lexbuf ; LTE }
| "=="  { adj lexbuf ; EQUALSEQUALS }
| "!="  { adj lexbuf ; NOTEQUALS }
| "["[^']']*"]" { str_adj lexbuf ; SOUND(strip (string_of lexbuf)) }
| "~"[^'~']*"~"
| '"'[^'"']*'"'
| '%'[^'%']*'%'  { str_adj lexbuf ; STRING(strip (string_of lexbuf)) }
| ['0'-'9''A'-'Z''a'-'z''_']['0'-'9''A'-'Z''a'-'z''#''_''-''.']* {
    adj lexbuf ; try Hashtbl.find lexicon (string_of lexbuf)
    with _ -> STRING(string_of lexbuf) }
| '#'['-']?['0'-'9']+ { adj lexbuf ;
      let str = string_of lexbuf in
      let str = String.sub str 1 ((String.length str) - 1) in
      STRING_REF((int_of_string str)) }
| '!'['-']?['0'-'9']+ { adj lexbuf ;
      let str = string_of lexbuf in
      let str = String.sub str 1 ((String.length str) - 1) in
      FORCED_STRING_REF((int_of_string str)) }
| '@'['-']?['0'-'9']+ { adj lexbuf ;
      let str = string_of lexbuf in
      let str = String.sub str 1 ((String.length str) - 1) in
      TRANS_REF((int_of_string str)) }
| "~~~~~" { adj lexbuf ; let buf = Buffer.create 255 in widestring buf lexbuf }
| "<<<<<<<<" [' ']* ([^'\n''\r']* as name) ('\r'?)'\n' {
  adj lexbuf ;
  let buf = Buffer.create 10240 in
  inlined name buf lexbuf }
| eof   { EOF }
| _	{ lex_error (Printf.sprintf "invalid character [%s]" (string_of
lexbuf)) }
and comment = parse
      "*/"	{ adj lexbuf ; () }
|     '\n'      { newline (); comment lexbuf }
|     "/*"      { adj lexbuf ; let _ = comment lexbuf in comment lexbuf } 
|     eof       { lex_error "unterminated comment" } 
|     _ 	{ adj lexbuf ; comment lexbuf }
and widestring buf = parse
|     "~~~~~"    { adj lexbuf ; STRING(Buffer.contents buf) }
|     eof        { lex_error "unterminated ~~~~~ string" }
|     '\n'       { newline (); Buffer.add_char buf '\n';widestring buf lexbuf}
|     _          { adj lexbuf ; let str = string_of lexbuf in
                   Buffer.add_string buf str ; widestring buf lexbuf } 
and inlined name buf = parse 
|     ">>>>>>>>"{ adj lexbuf ; 
                  INLINED_FILE(name,(Buffer.contents buf)) }
|     eof       { lex_error "unterminated inlined file" } 
|     '\n'      { newline (); Buffer.add_char buf '\n' ; 
                  inlined name buf lexbuf }
|     _         { adj lexbuf ; 
                  let str = string_of lexbuf in
                  Buffer.add_string buf str ;
                  inlined name buf lexbuf } 
and endline = parse 
        '\n' 			{ newline (); initial lexbuf}
|	_			{ adj lexbuf ; endline lexbuf}
|       eof                     { EOF }
